import java.util.*;
import java.awt.*;

public class Lab5174Environment extends Environment {
	public static int 	VERTICAL_SIZE = 160;	// lab environment height (cm)
	public static int	HORIZONTAL_SIZE = 213;	// lab environment width (cm)

	private ArrayList<Rectangle>	walls;

    public Lab5174Environment() {
    	super();

    	// Create the walls
		walls = new ArrayList<Rectangle>();

		walls.add(new Rectangle(0, 3, 213, 3));
		walls.add(new Rectangle(0, 160, 213, 3));
		walls.add(new Rectangle(0, 160, 3, 160));
		walls.add(new Rectangle(210, 160, 3, 160));

		centerRobot();
    }

    // Center the robot in  the environment
    public void centerRobot() {
    	robot.setPose(new Pose(0, HORIZONTAL_SIZE/2, VERTICAL_SIZE/2, 0));
    }
    
	// Return the height of the environment
	public int getHeightInPixels() {
		return (int)(VERTICAL_SIZE*PIXELS_PER_CM());
	}
	public int getWidthInPixels() {
		return (int)(HORIZONTAL_SIZE*PIXELS_PER_CM());
	}
	public double getHeightInCM() {
		return VERTICAL_SIZE;
	}
	public static int PIXELS_PER_CM() { return 4; }

    public void draw(java.awt.Graphics g, boolean solid, boolean outline) {
		for (Rectangle r: walls) {
			if (solid) {
				g.setColor(new Color(209, 196, 170));
				g.fillRect(r.x*PIXELS_PER_CM(), getHeightInPixels() - r.y*PIXELS_PER_CM(), r.width*PIXELS_PER_CM(), r.height*PIXELS_PER_CM());
			}
			if (outline) {
				g.setColor(java.awt.Color.LIGHT_GRAY);
				g.drawRect(r.x*PIXELS_PER_CM(), getHeightInPixels() - r.y*PIXELS_PER_CM(), r.width*PIXELS_PER_CM(), r.height*PIXELS_PER_CM());
			}
		}
	}
}