import java.util.*;
import java.awt.*;

public class ObstacleSet {
	private String 					description;
	private Color	 				color;
	private ArrayList<Position>		obstacles;
	private boolean					visible;

	public ObstacleSet(String desc, int r, int g, int b) {
		description = desc;
		obstacles = new ArrayList<Position>();
		color = new Color(r, g, b);
		visible = true;
	}

	public String getDescription() { return description; }
	public ArrayList<Position> getObstacles() { return obstacles; }
	public Position getObstacle(int i) { return obstacles.get(i); }
	public boolean isVisible() { return visible; }
	public void setVisible(boolean b) { visible = b; }

	public void reset() {
		obstacles.clear();
	}
	public boolean add(Position p) {
		obstacles.add(p);
		return true;
	}

    public void draw(Graphics g, Environment e) {
    	if (visible) {
    		for (int i=0; i<obstacles.size(); i++) {
    			Position p = obstacles.get(i);
				g.setColor(color);
				/*g.drawLine((int)(p.x*Environment.PIXELS_PER_CM()), e.getHeightInPixels() - (int)(p.y*Environment.PIXELS_PER_CM()),
						   (int)(p.x*Environment.PIXELS_PER_CM() + 5*Math.cos(Math.toRadians(p.angle))),
						   e.getHeightInPixels() - (int)(p.y*Environment.PIXELS_PER_CM() + 5*Math.sin(Math.toRadians(p.angle))));*/
				g.fillOval((int)(p.x*Environment.PIXELS_PER_CM())-2, e.getHeightInPixels() - (int)(p.y*Environment.PIXELS_PER_CM())-2, 5, 5);
			}
    	}
    }
}