import java.util.ArrayList;
import java.awt.Polygon;
import java.awt.Point;
//import java.util.PriorityQueue;

// This class is to be written by the user to perform path planning on a vector map
public class PathPlanner {
	private Point 				start;
	private Point	 			end;
	private ArrayList<Polygon> 	obstacles;

	// A Path Planner assumes a starting and end location as well as a collection of pbstacles
	public PathPlanner(Point s, Point e) {
		start = s;
		end = e;
	}

	// These are used to refresh the start or end points or the obstacle collection
	public void setStart(Point p) { start = p; }
	public void setEnd(Point p) { end = p; }

	// Compute the Support Points with respect to the given point
	public ArrayList<Point> computeSupportPointsFrom(ArrayList<Polygon> obst, int x, int y) {
		ArrayList<Point> supports = new ArrayList<Point>();

		// Add a line from the start to the destination (assumes no obstacles are in the way)
		if ((x != end.x) && (y != end.y)) {
			Point END = new Point(end.x, end.y);
			supports.add(END);
		}
		return supports;
	}


	// Create and return a new visibility graph for the given obstacle space
	public Graph computeVisibilityGraph(ArrayList<Polygon> obst) {
		Graph g = new Graph();
		
		return g;
	}


	// Compute the shortest path in the graph by selecting its nodes and edges in the visibility graph.
	public ArrayList<Node> computeShortestPath(Graph g, Node s, Node e) {
		ArrayList<Node>	path = new ArrayList<Node>();

		return path;
	}

	// Compute the shortest TURN path in the graph by selecting its nodes and edges in the visibility graph.
	public ArrayList<Node> computeShortestTurnPath(Graph g, Node s, Node e) {
		ArrayList<Node>	path = new ArrayList<Node>();

		return path;
	}



	// Grow the obstacles by an amount equivalent to the robot's size
	public ArrayList<Polygon>  computeGrownObstacleSpace(ArrayList<Polygon> obst, float robotRadius, int degreeUnit) {
		return obst;
	}


	// Determine the convex hull of a set of points
	public Polygon convexHull(ArrayList<Point> points) {
		Polygon hull = new Polygon();

		return hull;
	}

	// Decompose a polygon into triangles
	public ArrayList<Polygon> splitIntoTriangles(ArrayList<Polygon> polygons) {
		ArrayList<Polygon> triangles = new ArrayList<Polygon>();

		for (Polygon poly: polygons) {
			if (poly.npoints < 3)
				triangles.add(poly);
		}

		return triangles;
	}
}



