import java.awt.*;

public abstract class Robot {
	public static final int	GRAB_RADIUS = 20;	// The radius w.r.t. mouse location when grabbing the robot
	public static float SCALE = 1.0f;


	Pose 	pose;				// currentPose
	int		lastSensedColor;	// tile color sensed at previous pose
	int		currentSensedColor;		// tile color being sensed at current pose

	public Robot() {
		reset();
	}

	public void reset() {
		pose = new Pose(0, 300, 200, 0);
		lastSensedColor = Tile.NONE;
		currentSensedColor = Tile.NONE;
	}

	public Pose getPose() { return pose; }
	public void setPose(Pose p) { pose = p; }

	public int getCurrentSensedColor() { return currentSensedColor; }
	public int getLastSensedColor() { return lastSensedColor; }
	public void setCurrentSensedColor(int c) {
		lastSensedColor = currentSensedColor;
		currentSensedColor = c;
	}

	public void drawWith(Graphics g, Environment e) {
		drawWithPose(g, true, pose, e, Color.gray);
	}

	public void drawWithPose(Graphics g, Pose p, Environment e, Color c) {
		drawWithPose(g, false, p, e, c);
	}

	public abstract void drawWithPose(Graphics g, boolean solid, Pose p, Environment e, Color c);
	public abstract float getDiameter();
}