import java.awt.Color;

public class Tile {
	public static double WIDTH = 7.5;		// width (in cm) of a tiled cell
	public static double HEIGHT = 7.5;		// height (in cm) of a tiled cell

	public static final int BLUE = 0;
	public static final int BLACK = 1;
	public static final int YELLOW = 2;
	public static final int GRAY = 3;
	public static final int PURPLE = 4;
	public static final int ORANGE = 5;
	public static final int RED = 6;
	public static final int GREEN = 7;
	public static final int WHITE = 8;
	public static final int NONE = 9;

	public static String[] COLOR_NAMES = {"BLUE", "BLACK", "YELLOW", "GRAY", "PURPLE", "ORANGE", "RED", "GREEN", "WHITE", "NONE" };

	public static Color[] COLORS = {Color.BLUE, new Color(50,50,50), Color.YELLOW, new Color(128, 128, 128), new Color(200, 0, 255), new Color(255, 150, 0), Color.RED, Color.GREEN, Color.WHITE, };

	// This is the offset lookup tables for moving from one color to another
	public static int[][] X_OFFSETS  = {{0, 1, -1, 0, 1, -1, 0, 1, -1, 0},
										{-1, 0, 1, -1, 0, 1, -1, 0, 1, 0},
										{1, -1, 0, 1, -1, 0, 1, -1, 0, 0},		// MAY HAVE TO MOVE TOP 3 ROWS TO BOTTOM IN EACH OF THESE TABLES
										{0, 1, -1, 0, 1, -1, 0, 1, -1, 0},
										{-1, 0, 1, -1, 0, 1, -1, 0, 1, 0},
										{1, -1, 0, 1, -1, 0, 1, -1, 0, 0},
										{0, 1, -1, 0, 1, -1, 0, 1, -1, 0},
										{-1, 0, 1, -1, 0, 1, -1, 0, 1, 0},
										{1, -1, 0, 1, -1, 0, 1, -1, 0, 0},
										{0, 0, 0, 0, 0, 0, 0, 0, 0, 0}};
	public static int[][] Y_OFFSETS  = {{0, 0, 0, 1, 1, 1, -1, -1, -1, 0},
										{0, 0, 0, 1, 1, 1, -1, -1, -1, 0},
										{0, 0, 0, 1, 1, 1, -1, -1, -1, 0},
										{-1, -1, -1, 0, 0, 0, 1, 1, 1, 0},
										{-1, -1, -1, 0, 0, 0, 1, 1, 1, 0},
										{-1, -1, -1, 0, 0, 0, 1, 1, 1, 0},
										{1, 1, 1, -1, -1, -1, 0, 0, 0, 0},
										{1, 1, 1, -1, -1, -1, 0, 0, 0, 0},
										{1, 1, 1, -1, -1, -1, 0, 0, 0, 0},
										{0, 0, 0, 0, 0, 0, 0, 0, 0, 0}};
	public static int[][] A_OFFSETS  = {{0, 0, 180, 90, 45, 135, -90, -45, -135, 0},
										{180, 0, 0, 135, 90, 45, -135, -90, -45, 0},
										{0, 180, 0, 45, 135, 90, -45, -135, -90, 0},
										{-90, -45, -135, 0, 0, 180, 90, 45, 135, 0},
										{-135, -90, -45, 180, 0, 0, 135, 90, 45, 0},
										{-45, -135, -90, 0, 180, 0, 45, 135, 90, 0},
										{90, 45, 135, -90, -45, -135, 0, 0, 180, 0},
										{135, 90, 45, -135, -90, -45, 180, 0, 0, 0},
										{45, 135, 90, -45, -135, -90, 0, 180, 0, 0},
										{0, 0, 0, 0, 0, 0, 0, 0, 0, 0}};

	public double 	x;				// tile's bottom/left x coordinate
	public double	y;				// tile's bottom/left y coordinate
	public int		color;			// color of tile

	public Tile(double blx, double bly, int c) {
		this.x = blx;
		this.y = bly;
		this.color = c;
	}
}